"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var models_1 = require("./models");
exports.LogLevel = models_1.LogLevel;
var console_1 = require("./console");
exports.ConsoleLogger = console_1.ConsoleLogger;
var fs_1 = require("./fs");
exports.FileLogger = fs_1.FileLogger;
var loggers = [];
function debug() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    for (var _a = 0, loggers_1 = loggers; _a < loggers_1.length; _a++) {
        var l = loggers_1[_a];
        l.debug(args);
    }
}
exports.debug = debug;
function info() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    for (var _a = 0, loggers_2 = loggers; _a < loggers_2.length; _a++) {
        var l = loggers_2[_a];
        l.info(args);
    }
}
exports.info = info;
function ok() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    for (var _a = 0, loggers_3 = loggers; _a < loggers_3.length; _a++) {
        var l = loggers_3[_a];
        l.ok(args);
    }
}
exports.ok = ok;
function warn() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    for (var _a = 0, loggers_4 = loggers; _a < loggers_4.length; _a++) {
        var l = loggers_4[_a];
        l.warn(args);
    }
}
exports.warn = warn;
function error() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    for (var _a = 0, loggers_5 = loggers; _a < loggers_5.length; _a++) {
        var l = loggers_5[_a];
        l.error(args);
    }
}
exports.error = error;
function panic() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    for (var _a = 0, loggers_6 = loggers; _a < loggers_6.length; _a++) {
        var l = loggers_6[_a];
        l.panic(args);
    }
}
exports.panic = panic;
function add(logger) {
    loggers.push(logger);
}
exports.add = add;
// Handle exeptions and stuff
process.on('unhandledRejection', function (reason, _promise) {
    // Unhandled promise rejections are deprecated. In the future, promise rejections
    // that are not handled will terminate the Node.js process with a non-zero exit code.
    // @ts-ignore
    panic(reason ? reason.stack : 'Unhandled promise rejection. Details unknown.');
});
process.on('uncaughtException', function (err) {
    panic(err.stack);
});
